precision highp float;

uniform mat4 matrix;
uniform sampler2D sampler;

attribute vec4 position;
attribute vec2 uv;

varying vec2 fragment_uv;

void VS() {
    gl_Position = matrix * position;
    fragment_uv = uv;
}

void PS() {
    vec4 color = texture2D(sampler, fragment_uv);
    color.a = max(color.a, 0.4);
    gl_FragColor = color;
}